// Include file for Formula 1

f1Image=new Image();
f1Image.window=mainWindow;
f1Image.src="Images/f1.jpg";
f1Image.width=90;
f1Image.height=45;
f1Image.hOffset=0;
f1Image.vOffset=0;
f1Image.opacity=128;
f1Image.tooltip="Double click to open the Formula 1 web site";
f1Image.onMultiClick = "openURL(f1MainURL);";

f1ListTitleBackground=new Image();
f1ListTitleBackground.window=mainWindow;
f1ListTitleBackground.src="Images/top.png";
f1ListTitleBackground.width=266;
f1ListTitleBackground.height=18;
f1ListTitleBackground.hOffset=0;
f1ListTitleBackground.vOffset=f1Image.height;
f1ListTitleBackground.opacity=255;
f1ListTitleBackground.visible=false;

f1ShowList=new Image();
f1ShowList.window=mainWindow;
f1ShowList.src="Images/showList.png";
f1ShowList.width=7;
f1ShowList.height=7;
f1ShowList.hOffset=79;
f1ShowList.vOffset=33;
f1ShowList.opacity=255;
f1ShowList.visible=true;
f1ShowList.onMouseUp="f1DoList();";

f1HideList=new Image();
f1HideList.window=mainWindow;
f1HideList.src="Images/hideList.png";
f1HideList.width=7;
f1HideList.height=7;
f1HideList.hOffset=79;
f1HideList.vOffset=33;
f1HideList.opacity=255;
f1HideList.visible=false;
f1HideList.onMouseUp="f1DoList();";

f1ListTitleText=new Text();
f1ListTitleText.window=mainWindow;
f1ListTitleText.data="Formula 1 Season";
f1ListTitleText.alignment="center";
f1ListTitleText.hOffset=f1ListTitleBackground.width / 2;
f1ListTitleText.vOffset=f1ListTitleBackground.vOffset + 11;
f1ListTitleText.size=12;
f1ListTitleText.color="#000000";
f1ListTitleText.font="Courier New Bold";
f1ListTitleText.opacity=255;
f1ListTitleText.visible=false;

f1Title=new Text();
f1Title.window=mainWindow;
f1Title.data="Formula 1";
f1Title.alignment="center";
f1Title.width=90;
f1Title.hOffset=45;
f1Title.vOffset=40;
f1Title.size=12;
f1Title.color="#000000";
f1Title.font="Courier New Bold";
f1Title.opacity=255;
f1Title.tooltip="Display the Formula 1 season";
f1Title.onMouseUp="f1DoList();";

f1NextEvent=new Text();
f1NextEvent.window=mainWindow;
f1NextEvent.data="???";
f1NextEvent.alignment="center";
f1NextEvent.hOffset=45;
f1NextEvent.vOffset=12;
f1NextEvent.size=12;
f1NextEvent.color="#000000";
f1NextEvent.font="Courier New Bold";
f1NextEvent.opacity=255;

var f1ServerURL = "http://f1.racing-live.com/";
//var f1MainURL = f1ServerURL + "f1/en/";
var f1MainURL = preferences.f1main.value;
var f1CalendarURL = preferences.f1calendar.value + "/index" + preferences.calendarForYear.value + ".shtml";
var f1NextEventIndex;
var f1NumberOfEvents;
var f1EventData = new Array();
var f1ListData = new Array();
var f1ListBackground = new Array();
var f1ListState = preferences.f1ListState.value;

function f1GetData(){
	f1NextEvent.data = "Fetching.."
	f1Image.opacity=128;
	updateNow();
	delete f1URL;
	f1URL = new URL();
	f1URL.location = f1CalendarURL;
	f1URL.fetch();
	log("Response was: " + f1URL.response);

	if ( f1URL.response == 200 ) {
		f1Image.opacity=255;
	} else {
		log("Location was: " + f1URL.location);
		log("Result was: " + f1URL.result);
		f1NextEvent.data = "Failed!!";
		return;
	}

	f1NumberOfEvents = 0;
	var str=f1URL.result.match(/^.+$/mg);;
//	print("-----------------------------------------------------------");
	for (y in str) {
		if ( str[y].match(/^<table background.*classement.*$/) != null) {
			f1NumberOfEvents++;
			f1GetEventData(str,y,f1NumberOfEvents);
		}
	}
	if (f1NextEvent.data == "Fetching.." ) {
		f1NextEvent.data = "All Run"
	}
	f1CreateList();
}

function f1GetEventData(str,startrow,eventnum){
	delete f1EventData[eventnum];
	f1EventData[eventnum] = new Array();
	f1EventData[eventnum].window = mainWindow;
	var rownum = startrow;
	rownum++;
	f1EventData[eventnum]["when"] = str[rownum + 1].replace(/^.*bold>(.*)<\/td>$/,"$1");
	f1EventData[eventnum]["when"] = f1EventData[eventnum]["when"].replace(/-..\//,"\/");
	f1EventData[eventnum]["when"] = f1EventData[eventnum]["when"].replace(/-.\//,"\/");
	f1EventData[eventnum]["flag"] = str[rownum + 2].replace(/^.*img src=(.*) border=0><\/td>$/,"$1");
	f1EventData[eventnum]["where"] = str[rownum + 3].replace(/^.*border=0><b>(.*)<\/b><\/td>$/,"$1");
	f1EventData[eventnum]["circuiturl"] = str[rownum + 4].replace(/^.*<a href=\"(.*)\"><img.*$/,"$1");
	f1EventData[eventnum]["circuitpic"] = str[rownum + 4].replace(/^.*img src=(.*) border=0.*$/,"$1");
	f1EventData[eventnum]["circuit"] = str[rownum + 5].replace(/^.*norm><b>(.*)<\/b><\/td>$/,"$1");
	f1EventData[eventnum]["podium1"] = str[rownum + 9].replace(/^.*boldrg>(.*)<\/font><br>$/,"$1");
	f1EventData[eventnum]["podium2"] = str[rownum + 10].replace(/^.*2\. (.*)<br>$/,"$1");
	f1EventData[eventnum]["podium3"] = str[rownum + 11].replace(/^.*3\. (.*)$/,"$1");
	f1EventData[eventnum]["podium3"] = f1EventData[eventnum]["podium3"].replace(/<\/td>/,"");

	var re1 = /^(.*\/)(.*\/)(.*)$/;
	var tempdate = f1EventData[eventnum]["when"].replace(re1,"$2") + f1EventData[eventnum]["when"].replace(re1,"$1") + f1EventData[eventnum]["when"].replace(re1,"$3");
//	print("f1EventData[eventnum][when] = |" + f1EventData[eventnum]["when"] + "|");
//	print("tempdate = " + tempdate);
//	f1EventData[eventnum]["daystogo"] = updateTime(tempdate);
	f1EventData[eventnum]["daystogo"] = getDays(tempdate);
	if (f1EventData[eventnum]["daystogo"] == "1 days") {
		f1EventData[eventnum]["daystogo"] = "Tomorrow"
	}
	if (f1EventData[eventnum]["daystogo"] == "0 days") {
		f1EventData[eventnum]["daystogo"] = "Today"
	}

	if (f1NextEvent.data == "Fetching.." ) {
		if (f1EventData[eventnum]["daystogo"] != "Run!") {
			f1NextEvent.data = f1EventData[eventnum]["daystogo"];
			f1NextEventIndex = eventnum;
		}
	}
}

function f1CreateList() {
//	print("f1CreateList");
	for (eventnum = 1 ; eventnum <= f1NumberOfEvents ; eventnum++) {
		delete f1ListBackground[eventnum];
		f1ListBackground[eventnum] = new Image();
		f1ListBackground[eventnum].window = mainWindow;
		f1ListBackground[eventnum].src = "Images/row.png";
		f1ListBackground[eventnum].vOffset = f1Image.height + f1ListTitleBackground.height + (eventnum-1) * 18;
		f1ListBackground[eventnum].hOffset = 0;
		f1ListBackground[eventnum].width = 266;
		f1ListBackground[eventnum].height = 18;
		f1ListBackground[eventnum].opacity = 255;
		f1ListBackground[eventnum].colorize = preferences.f1ColorPref.value;
		f1ListBackground[eventnum].visible=false;

		delete f1ListData[eventnum];
		f1ListData[eventnum] = new Text();
		f1ListData[eventnum].window = mainWindow;
		f1ListData[eventnum].data = padright(f1EventData[eventnum]["where"]," ",14) + padleft(f1EventData[eventnum]["when"],"0",10) + "  " + f1EventData[eventnum]["daystogo"];
		f1ListData[eventnum].vOffset = f1ListBackground[eventnum].vOffset + 11;
		f1ListData[eventnum].hOffset = 7;
		f1ListData[eventnum].color = preferences.offColorPref.value;
		f1ListData[eventnum].width = 266;
		f1ListData[eventnum].height = 12;
		f1ListData[eventnum].opacity = 255;
		f1ListData[eventnum].font = "Courier New Bold";
		f1ListData[eventnum].size = 12;
		f1ListData[eventnum].visible=false;
		f1ListData[eventnum].onMouseEnter = "f1EventMouseEnter(" + eventnum + ");";
		f1ListData[eventnum].onMouseExit = "f1EventMouseExit(" + eventnum + ");";
//		f1ListData[eventnum].onMouseUp = "openURL(\"" + f1ServerURL + f1EventData[eventnum]["circuiturl"] + "\");";

		if(eventnum == f1NextEventIndex) {
			f1ListData[eventnum].color = nextColor;
			f1ListData[eventnum].opacity=255;
		}

//		print(f1EventData[eventnum]["when"] + "  " + f1EventData[eventnum]["flag"] + "  " + f1EventData[eventnum]["where"]);
//		print(f1EventData[eventnum]["circuiturl"] + "  " + f1EventData[eventnum]["circuitpic"] + "  " + f1EventData[eventnum]["circuit"]);
//		print(f1EventData[eventnum]["podium1"] + "  " + f1EventData[eventnum]["podium2"] + "  " + f1EventData[eventnum]["podium3"]);
//		print("-----------------------------------------------------------");
	}
}
	
function f1EventMouseEnter(eventnum) {
	f1ListData[eventnum].color = onColor;
	f1ListData[eventnum].opacity = 255;
	podiumTitleBackground.vOffset = f1ListBackground[eventnum].vOffset - 18;
	podiumTitleBackground.visible = true;
	podiumTitleText.data = f1EventData[eventnum]["circuit"];
	podiumTitleText.vOffset = podiumTitleBackground.vOffset + 11;
	podiumTitleText.visible = true;
	podiumBackground1.vOffset = podiumTitleBackground.vOffset +18;
	podiumBackground2.vOffset = podiumTitleBackground.vOffset +36;
	podiumBackground3.vOffset = podiumTitleBackground.vOffset +54;
	podiumBackground1.visible = true;
	podiumBackground2.visible = true;
	podiumBackground3.visible = true;
	podium1.data = "1. " + f1EventData[eventnum]["podium1"];
	podium2.data = "2. " + f1EventData[eventnum]["podium2"];
	podium3.data = "3. " + f1EventData[eventnum]["podium3"];
	if (podium1.data == "1. ?.?????" || podium1.data == "1. ?.??????") {
		podium1.data = "";
		podium2.data = "";
		podium3.data = "";
	}
	podium1.vOffset = podiumBackground1.vOffset + 11;
	podium2.vOffset = podiumBackground2.vOffset + 11;
	podium3.vOffset = podiumBackground3.vOffset + 11;
	podium1.visible = true;
	podium2.visible = true;
	podium3.visible = true;
}

function f1EventMouseExit(eventnum) {
	if (eventnum == f1NextEventIndex) {
		f1ListData[eventnum].color = nextColor;
		f1ListData[eventnum].opacity = 255;
	} else {
		f1ListData[eventnum].color = offColor;
		f1ListData[eventnum].opacity = 255;
	}
	podiumTitleBackground.visible = false;
	podiumTitleText.visible = false;
	podiumBackground1.visible = false;
	podiumBackground2.visible = false;
	podiumBackground3.visible = false;
	podium1.visible = false;
	podium2.visible = false;
	podium3.visible = false;
}

function f1DoList() {
	motogpCloseList();
	wrcCloseList();
	if (f1ListState == "open") {
		f1CloseList();
	} else {
		f1OpenList();
	}
}

function f1OpenList() {
	f1ListTitleBackground.visible=true;
	f1ListTitleText.visible=true;
	f1ListState = preferences.f1ListState.value = "open";
	for(i = 1; i <= f1NumberOfEvents; i++) {
		f1ListBackground[i].visible=true;
		f1ListData[i].visible=true;
	}
	f1ShowList.visible=false;
	f1HideList.visible=true;
	motogpImage.opacity=128;
	wrcImage.opacity=128;
}

function f1CloseList() {
	if (preferences.f1ListState.value == "closed") {
		return;
	}
	for(i = 1; i <= f1NumberOfEvents; i++) {
		f1ListBackground[i].visible=false;
		f1ListData[i].visible=false;
	}
	f1ListTitleBackground.visible=false;
	f1ListTitleText.visible=false;
	f1ListState = preferences.f1ListState.value = "closed";
	f1ShowList.visible=true;
	f1HideList.visible=false;
	motogpImage.opacity=255;
	wrcImage.opacity=255;
}

