// Include file for Moto GP

motogpImage=new Image();
motogpImage.window=mainWindow;
motogpImage.src="Images/motogp.jpg";
motogpImage.width=90;
motogpImage.height=45;
motogpImage.hOffset=88;
motogpImage.vOffset=0;
motogpImage.opacity=255;
motogpImage.tooltip="Double click to open the MotoGP web site";
motogpImage.onMultiClick = "openURL(motogpMainURL);";

motogpListTitleBackground=new Image();
motogpListTitleBackground.window=mainWindow;
motogpListTitleBackground.src="Images/top.png";
motogpListTitleBackground.width=266;
motogpListTitleBackground.height=18;
motogpListTitleBackground.hOffset=0;
motogpListTitleBackground.vOffset=motogpImage.height;
motogpListTitleBackground.opacity=255;
motogpListTitleBackground.visible=false;

motogpShowList=new Image();
motogpShowList.window=mainWindow;
motogpShowList.src="Images/showList.png";
motogpShowList.width=7;
motogpShowList.height=7;
motogpShowList.hOffset=167;
motogpShowList.vOffset=33;
motogpShowList.opacity=255;
motogpShowList.visible=true;
motogpShowList.onMouseUp="motogpDoList();";

motogpHideList=new Image();
motogpHideList.window=mainWindow;
motogpHideList.src="Images/hideList.png";
motogpHideList.width=7;
motogpHideList.height=7;
motogpHideList.hOffset=167;
motogpHideList.vOffset=33;
motogpHideList.opacity=255;
motogpHideList.visible=false;
motogpHideList.onMouseUp="motogpDoList();";

motogpListTitleText=new Text();
motogpListTitleText.window=mainWindow;
motogpListTitleText.data="MotoGP Season";
motogpListTitleText.alignment="center";
motogpListTitleText.hOffset=motogpListTitleBackground.width / 2;
motogpListTitleText.vOffset=motogpListTitleBackground.vOffset + 11;
motogpListTitleText.size=12;
motogpListTitleText.color="#000000";
motogpListTitleText.font="Courier New Bold";
motogpListTitleText.opacity=255;
motogpListTitleText.visible=false;

motogpTitle=new Text();
motogpTitle.window=mainWindow;
motogpTitle.data="MotoGP";
motogpTitle.alignment="center";
motogpTitle.width=90;
motogpTitle.hOffset=132;
motogpTitle.vOffset=40;
motogpTitle.size=12;
motogpTitle.color="#000000";
motogpTitle.font="Courier New Bold";
motogpTitle.opacity=255;
motogpTitle.tooltip="Display the MotoGP season";
motogpTitle.onMouseUp="motogpDoList();";

motogpNextEvent=new Text();
motogpNextEvent.window=mainWindow;
motogpNextEvent.data="???";
motogpNextEvent.alignment="center";
motogpNextEvent.hOffset=132;
motogpNextEvent.vOffset=12;
motogpNextEvent.size=12;
motogpNextEvent.color="#000000";
motogpNextEvent.font="Courier New Bold";
motogpNextEvent.opacity=255;

var motogpServerURL = "http://motogp.racing-live.com/";
//var motogpMainURL = motogpServerURL + "motogp/en/";
//var motogpCalendarURL = motogpMainURL + "calendar/index" + preferences.calendarForYear.value + ".shtml";
var motogpMainURL = preferences.motogpmain.value;
var motogpCalendarURL = preferences.motogpcalendar.value + "/index" + preferences.calendarForYear.value + ".shtml";
var motogpNextEventIndex;
var motogpNumberOfEvents;
var motogpEventData = new Array();
var motogpListData = new Array();
var motogpListBackground = new Array();
var motogpListState = preferences.motogpListState.value;

function motogpGetData(){
	motogpNextEvent.data = "Fetching.."
	motogpImage.opacity=128;
	updateNow();
	delete motogpURL;
	motogpURL = new URL();
	motogpURL.location = motogpCalendarURL;
	motogpURL.fetch();
	log("Response was: " + motogpURL.response);

	if ( motogpURL.response == 200 ) {
		motogpImage.opacity=255;
	} else {
		log("Location was: " + motogpURL.location);
		log("Result was: " + motogpURL.result);
		motogpNextEvent.data = "Failed!!";
		return;
	}

	motogpNumberOfEvents = 0;
	var str=motogpURL.result.match(/^.+$/mg);;
//	print("-----------------------------------------------------------");
	for (y in str) {
		if ( str[y].match(/^<table background.*classement.*$/) != null) {
			motogpNumberOfEvents++;
			motogpGetEventData(str,y,motogpNumberOfEvents);
		}
	}
	if (motogpNextEvent.data == "Fetching.." ) {
		motogpNextEvent.data = "All Run"
	}
	motogpCreateList();
}

function motogpGetEventData(str,startrow,eventnum){
	delete motogpEventData[eventnum];
	motogpEventData[eventnum] = new Array();
	motogpEventData[eventnum].window = mainWindow;
	var rownum = startrow;
	rownum++;
	rownum++;
	motogpEventData[eventnum]["when"] = str[rownum++].replace(/^.*bold>(.*)<\/td>$/,"$1");
	motogpEventData[eventnum]["when"] = motogpEventData[eventnum]["when"].replace(/-..\//,"\/");
	motogpEventData[eventnum]["when"] = motogpEventData[eventnum]["when"].replace(/-.\//,"\/");
	motogpEventData[eventnum]["flag"] = str[rownum++].replace(/^.*img src=(.*) border=0><\/td>$/,"$1");
	motogpEventData[eventnum]["where"] = str[rownum++].replace(/^.*border=0><b>(.*)<\/b>.*$/,"$1");
	if (str[rownum].match(/circuits/) == null) {
		rownum++;
	}
	motogpEventData[eventnum]["circuiturl"] = str[rownum].replace(/^.*<a href=\"(.*)\">\-\-><img.*$/,"$1");
	motogpEventData[eventnum]["circuitpic"] = str[rownum++].replace(/^.*img src=(.*) border=0.*$/,"$1");
	motogpEventData[eventnum]["circuit"] = str[rownum++].replace(/^.*norm><b>(.*)<\/b><\/td>$/,"$1");
	rownum+=3;
	motogpEventData[eventnum]["podium1"] = str[rownum++].replace(/^.*boldrg>(.*)<\/font><br>$/,"$1");
	motogpEventData[eventnum]["podium2"] = str[rownum++].replace(/^.*2\. (.*)<br>$/,"$1");
	motogpEventData[eventnum]["podium3"] = str[rownum].replace(/^.*3\. (.*)$/,"$1");
	motogpEventData[eventnum]["podium3"] = motogpEventData[eventnum]["podium3"].replace(/<\/td>/,"");

	var re1 = /^(.*\/)(.*\/)(.*)$/;
	var tempdate = motogpEventData[eventnum]["when"].replace(re1,"$2") + motogpEventData[eventnum]["when"].replace(re1,"$1") + motogpEventData[eventnum]["when"].replace(re1,"$3");
//	print("motogpEventData[eventnum][when] = |" + motogpEventData[eventnum]["when"] + "|");
//	print("tempdate = " + tempdate);
//	motogpEventData[eventnum]["daystogo"] = updateTime(tempdate);
	motogpEventData[eventnum]["daystogo"] = getDays(tempdate);
	if (motogpEventData[eventnum]["daystogo"] == "1 days") {
		motogpEventData[eventnum]["daystogo"] = "Tomorrow"
	}
	if (motogpEventData[eventnum]["daystogo"] == "0 days") {
		motogpEventData[eventnum]["daystogo"] = "Today"
	}

	if (motogpNextEvent.data == "Fetching.." ) {
		if (motogpEventData[eventnum]["daystogo"] != "Run!") {
			motogpNextEvent.data = motogpEventData[eventnum]["daystogo"];
			motogpNextEventIndex = eventnum;
		}
	}
}

function motogpCreateList() {
//	print("motogpCreateList");
	for (eventnum = 1 ; eventnum <= motogpNumberOfEvents ; eventnum++) {
		delete motogpListBackground[eventnum];
		motogpListBackground[eventnum] = new Image();
		motogpListBackground[eventnum].window = mainWindow;
		motogpListBackground[eventnum].src = "Images/row.png";
		motogpListBackground[eventnum].vOffset = motogpImage.height + motogpListTitleBackground.height + (eventnum-1) * 18;
		motogpListBackground[eventnum].hOffset = 0;
		motogpListBackground[eventnum].width = 266;
		motogpListBackground[eventnum].height = 18;
		motogpListBackground[eventnum].opacity = 255;
		motogpListBackground[eventnum].colorize = preferences.motogpColorPref.value;
		motogpListBackground[eventnum].visible=false;

		delete motogpListData[eventnum];
		motogpListData[eventnum] = new Text();
		motogpListData[eventnum].window = mainWindow;
		motogpListData[eventnum].data = padright(motogpEventData[eventnum]["where"]," ",14) + padleft(motogpEventData[eventnum]["when"],"0",10) + "  " + motogpEventData[eventnum]["daystogo"];
		motogpListData[eventnum].vOffset = motogpListBackground[eventnum].vOffset + 11;
		motogpListData[eventnum].hOffset = 7;
		motogpListData[eventnum].color = preferences.offColorPref.value;
		motogpListData[eventnum].width = 266;
		motogpListData[eventnum].height = 12;
		motogpListData[eventnum].opacity = 255;
		motogpListData[eventnum].font = "Courier New Bold";
		motogpListData[eventnum].size = 12;
		motogpListData[eventnum].visible=false;
		motogpListData[eventnum].onMouseEnter = "motogpEventMouseEnter(" + eventnum + ");";
		motogpListData[eventnum].onMouseExit = "motogpEventMouseExit(" + eventnum + ");";
//		motogpListData[eventnum].onMouseUp = "openURL(\"" + motogpServerURL + motogpEventData[eventnum]["circuiturl"] + "\");";

		if(eventnum == motogpNextEventIndex) {
			motogpListData[eventnum].color = nextColor;
			motogpListData[eventnum].opacity=255;
		}

//		print(motogpEventData[eventnum]["when"] + "  " + motogpEventData[eventnum]["flag"] + "  " + motogpEventData[eventnum]["where"]);
//		print(motogpEventData[eventnum]["circuiturl"] + "  " + motogpEventData[eventnum]["circuitpic"] + "  " + motogpEventData[eventnum]["circuit"]);
//		print(motogpEventData[eventnum]["podium1"] + "  " + motogpEventData[eventnum]["podium2"] + "  " + motogpEventData[eventnum]["podium3"]);
//		print("-----------------------------------------------------------");
	}
}
	
function motogpEventMouseEnter(eventnum) {
	motogpListData[eventnum].color = onColor;
	motogpListData[eventnum].opacity = 255;
	podiumTitleBackground.vOffset = motogpListBackground[eventnum].vOffset - 18;
	podiumTitleBackground.visible = true;
	podiumTitleText.data = motogpEventData[eventnum]["circuit"];
	podiumTitleText.vOffset = podiumTitleBackground.vOffset + 11;
	podiumTitleText.visible = true;
	podiumBackground1.vOffset = podiumTitleBackground.vOffset +18;
	podiumBackground2.vOffset = podiumTitleBackground.vOffset +36;
	podiumBackground3.vOffset = podiumTitleBackground.vOffset +54;
	podiumBackground1.visible = true;
	podiumBackground2.visible = true;
	podiumBackground3.visible = true;
	podium1.data = "1. " + motogpEventData[eventnum]["podium1"];
	podium2.data = "2. " + motogpEventData[eventnum]["podium2"];
	podium3.data = "3. " + motogpEventData[eventnum]["podium3"];
	if (podium1.data == "1. ?.?????" || podium1.data == "1. ?.??????") {
		podium1.data = "";
		podium2.data = "";
		podium3.data = "";
	}
	podium1.vOffset = podiumBackground1.vOffset + 11;
	podium2.vOffset = podiumBackground2.vOffset + 11;
	podium3.vOffset = podiumBackground3.vOffset + 11;
	podium1.visible = true;
	podium2.visible = true;
	podium3.visible = true;
}

function motogpEventMouseExit(eventnum) {
	if (eventnum == motogpNextEventIndex) {
		motogpListData[eventnum].color = nextColor;
		motogpListData[eventnum].opacity = 255;
	} else {
		motogpListData[eventnum].color = offColor;
		motogpListData[eventnum].opacity = 255;
	}
	podiumTitleBackground.visible = false;
	podiumTitleText.visible = false;
	podiumBackground1.visible = false;
	podiumBackground2.visible = false;
	podiumBackground3.visible = false;
	podium1.visible = false;
	podium2.visible = false;
	podium3.visible = false;
}

function motogpDoList() {
	f1CloseList();
	wrcCloseList();
	if (motogpListState == "open") {
		motogpCloseList();
	} else {
		motogpOpenList();
	}
}

function motogpOpenList() {
	motogpListTitleBackground.visible=true;
	motogpListTitleText.visible=true;
	motogpListState = preferences.motogpListState.value = "open";
	for(i = 1; i <= motogpNumberOfEvents; i++) {
		motogpListBackground[i].visible=true;
		motogpListData[i].visible=true;
	}
	motogpShowList.visible=false;
	motogpHideList.visible=true;
	f1Image.opacity=128;
	wrcImage.opacity=128;
}

function motogpCloseList() {
	if (preferences.motogpListState.value == "closed") {
		return;
	}
	for(i = 1; i <= motogpNumberOfEvents; i++) {
		motogpListBackground[i].visible=false;
		motogpListData[i].visible=false;
	}
	motogpListTitleBackground.visible=false;
	motogpListTitleText.visible=false;
	motogpListState = preferences.motogpListState.value = "closed";
	motogpShowList.visible=true;
	motogpHideList.visible=false;
	f1Image.opacity=255;
	wrcImage.opacity=255;
}

