// Include file for WRC

wrcImage=new Image();
wrcImage.window=mainWindow;
wrcImage.src="Images/wrc.jpg";
wrcImage.width=90;
wrcImage.height=45;
wrcImage.hOffset=176;
wrcImage.vOffset=0;
wrcImage.opacity=255;
wrcImage.tooltip="Double click to open the World Rally web site";
wrcImage.onMultiClick = "openURL(wrcMainURL);";

wrcListTitleBackground=new Image();
wrcListTitleBackground.window=mainWindow;
wrcListTitleBackground.src="Images/top.png";
wrcListTitleBackground.width=266;
wrcListTitleBackground.height=18;
wrcListTitleBackground.hOffset=0;
wrcListTitleBackground.vOffset=wrcImage.height;
wrcListTitleBackground.opacity=255;
wrcListTitleBackground.visible=false;

wrcShowList=new Image();
wrcShowList.window=mainWindow;
wrcShowList.src="Images/showList.png";
wrcShowList.width=7;
wrcShowList.height=7;
wrcShowList.hOffset=255;
wrcShowList.vOffset=33;
wrcShowList.opacity=255;
wrcShowList.visible=true;
wrcShowList.onMouseUp="wrcDoList();";

wrcHideList=new Image();
wrcHideList.window=mainWindow;
wrcHideList.src="Images/hideList.png";
wrcHideList.width=7;
wrcHideList.height=7;
wrcHideList.hOffset=255;
wrcHideList.vOffset=33;
wrcHideList.opacity=255;
wrcHideList.visible=false;
wrcHideList.onMouseUp="wrcDoList();";

wrcListTitleText=new Text();
wrcListTitleText.window=mainWindow;
wrcListTitleText.data="World Rally Championship Season";
wrcListTitleText.alignment="center";
wrcListTitleText.hOffset=wrcListTitleBackground.width / 2;
wrcListTitleText.vOffset=wrcListTitleBackground.vOffset + 11;
wrcListTitleText.size=12;
wrcListTitleText.color="#000000";
wrcListTitleText.font="Courier New Bold";
wrcListTitleText.opacity=255;
wrcListTitleText.visible=false;

wrcTitle=new Text();
wrcTitle.window=mainWindow;
wrcTitle.data="WRC";
wrcTitle.alignment="center";
wrcTitle.width=90;
wrcTitle.hOffset=221;
wrcTitle.vOffset=40;
wrcTitle.size=12;
wrcTitle.color="#000000";
wrcTitle.font="Courier New Bold";
wrcTitle.opacity=255;
wrcTitle.tooltip="Display the World Rally season";
wrcTitle.onMouseUp="wrcDoList();";

wrcNextEvent=new Text();
wrcNextEvent.window=mainWindow;
wrcNextEvent.data="???";
wrcNextEvent.alignment="center";
wrcNextEvent.hOffset=221;
wrcNextEvent.vOffset=12;
wrcNextEvent.size=12;
wrcNextEvent.color="#000000";
wrcNextEvent.font="Courier New Bold";
wrcNextEvent.opacity=255;

var wrcServerURL = "http://rally.racing-live.com/";
//var wrcMainURL = wrcServerURL + "wrc/en/";
//var wrcCalendarURL = wrcMainURL + "calendar/index" + preferences.calendarForYear.value + ".shtml";
var wrcMainURL = preferences.wrcmain.value;
var wrcCalendarURL = preferences.wrccalendar.value + "/index" + preferences.calendarForYear.value + ".shtml";
var wrcNextEventIndex;
var wrcNumberOfEvents;
var wrcEventData = new Array();
var wrcListData = new Array();
var wrcListBackground = new Array();
var wrcListState = preferences.wrcListState.value;

function wrcGetData(){
	wrcNextEvent.data = "Fetching.."
	wrcImage.opacity=128;
	updateNow();
	delete wrcURL;
	wrcURL = new URL();
	wrcURL.location = wrcCalendarURL;
	wrcURL.fetch();
	log("Response was: " + wrcURL.response);

	if ( wrcURL.response == 200 ) {
		wrcImage.opacity=255;
	} else {
		log("Location was: " + wrcURL.location);
		log("Result was: " + wrcURL.result);
		wrcNextEvent.data = "Failed!!";
		return;
	}

	wrcNumberOfEvents = 0;
	var str=wrcURL.result.match(/^.+$/mg);;
//	print("-----------------------------------------------------------");
	for (y in str) {
		if ( str[y].match(/<table background.*classement/) != null) {
			wrcNumberOfEvents++;
			wrcGetEventData(str,y,wrcNumberOfEvents);
		}
	}
	if (wrcNextEvent.data == "Fetching.." ) {
		wrcNextEvent.data = "All Run"
	}
	wrcCreateList();
}

function wrcGetEventData(str,startrow,eventnum){
	delete wrcEventData[eventnum];
	wrcEventData[eventnum] = new Array();
	wrcEventData[eventnum].window = mainWindow;
	var rownum = startrow;
	rownum++;
	wrcEventData[eventnum]["when"] = str[rownum + 1].replace(/^.*bold>(.*)<\/td>$/,"$1");
	wrcEventData[eventnum]["when"] = wrcEventData[eventnum]["when"].replace(/-..\//,"\/");
	wrcEventData[eventnum]["when"] = wrcEventData[eventnum]["when"].replace(/-.\//,"\/");
	wrcEventData[eventnum]["flag"] = str[rownum + 2].replace(/^.*img src=(.*) border=0><\/td>$/,"$1");
	wrcEventData[eventnum]["where"] = str[rownum + 3].replace(/^.*border=0><b>(.*)<\/b><\/td>$/,"$1");
	wrcEventData[eventnum]["circuiturl"] = str[rownum + 4].replace(/^.*<a href=\"(.*)\">\-\-><img.*$/,"$1");
	wrcEventData[eventnum]["circuitpic"] = str[rownum + 4].replace(/^.*img src=(.*) border=0.*$/,"$1");
	wrcEventData[eventnum]["circuit"] = str[rownum + 5].replace(/^.*norm><b>(.*)<\/b>.*$/i,"$1");
	wrcEventData[eventnum]["circuit"] = wrcEventData[eventnum]["circuit"].replace(/^(.*)<br>.*$/i,"$1");
	wrcEventData[eventnum]["podium1"] = str[rownum + 9].replace(/^.*boldrg>(.*)<\/font><br>$/,"$1");
	wrcEventData[eventnum]["podium2"] = str[rownum + 10].replace(/^.*2\. (.*)<br>$/,"$1");
	wrcEventData[eventnum]["podium3"] = str[rownum + 11].replace(/^.*3\. (.*)$/,"$1");
	wrcEventData[eventnum]["podium3"] = wrcEventData[eventnum]["podium3"].replace(/<\/td>/,"");

	if (wrcEventData[eventnum]["when"].length > 10) {
		var re1 = /^(.*\/)(.*\/)(.*\/)(.*)$/;
		wrcEventData[eventnum]["when"] = wrcEventData[eventnum]["when"].replace(re1,"$1") + wrcEventData[eventnum]["when"].replace(re1,"$2") + wrcEventData[eventnum]["when"].replace(re1,"$4");
	}
	var re1 = /^(.*\/)(.*\/)(.*)$/;
	var tempdate = wrcEventData[eventnum]["when"].replace(re1,"$2") + wrcEventData[eventnum]["when"].replace(re1,"$1") + wrcEventData[eventnum]["when"].replace(re1,"$3");
//	print("wrcEventData[eventnum][when] = |" + wrcEventData[eventnum]["when"] + "|");
//	print("tempdate = " + tempdate);
//	wrcEventData[eventnum]["daystogo"] = updateTime(tempdate);
	wrcEventData[eventnum]["daystogo"] = getDays(tempdate);
	if (wrcEventData[eventnum]["daystogo"] == "1 days") {
		wrcEventData[eventnum]["daystogo"] = "Tomorrow"
	}
	if (wrcEventData[eventnum]["daystogo"] == "0 days") {
		wrcEventData[eventnum]["daystogo"] = "Today"
	}

	if (wrcNextEvent.data == "Fetching.." ) {
		if (wrcEventData[eventnum]["daystogo"] != "Run!") {
			wrcNextEvent.data = wrcEventData[eventnum]["daystogo"];
			wrcNextEventIndex = eventnum;
		}
	}
}

function wrcCreateList() {
//	print("wrcCreateList");
	for (eventnum = 1 ; eventnum <= wrcNumberOfEvents ; eventnum++) {
		delete wrcListBackground[eventnum];
		wrcListBackground[eventnum] = new Image();
		wrcListBackground[eventnum].window = mainWindow;
		wrcListBackground[eventnum].src = "Images/row.png";
		wrcListBackground[eventnum].vOffset = wrcImage.height + wrcListTitleBackground.height + (eventnum-1) * 18;
		wrcListBackground[eventnum].hOffset = 0;
		wrcListBackground[eventnum].width = 266;
		wrcListBackground[eventnum].height = 18;
		wrcListBackground[eventnum].opacity = 255;
		wrcListBackground[eventnum].colorize = preferences.wrcColorPref.value;
		wrcListBackground[eventnum].visible=false;

		delete wrcListData[eventnum];
		wrcListData[eventnum] = new Text();
		wrcListData[eventnum].window = mainWindow;
		wrcListData[eventnum].data = padright(wrcEventData[eventnum]["where"]," ",14) + padleft(wrcEventData[eventnum]["when"],"0",10) + "  " + wrcEventData[eventnum]["daystogo"];
		wrcListData[eventnum].vOffset = wrcListBackground[eventnum].vOffset + 11;
		wrcListData[eventnum].hOffset = 7;
		wrcListData[eventnum].color = preferences.offColorPref.value;
		wrcListData[eventnum].width = 266;
		wrcListData[eventnum].height = 12;
		wrcListData[eventnum].opacity = 255;
		wrcListData[eventnum].font = "Courier New Bold";
		wrcListData[eventnum].size = 12;
		wrcListData[eventnum].visible=false;
		wrcListData[eventnum].onMouseEnter = "wrcEventMouseEnter(" + eventnum + ");";
		wrcListData[eventnum].onMouseExit = "wrcEventMouseExit(" + eventnum + ");";
//		wrcListData[eventnum].onMouseUp = "openURL(\"" + wrcServerURL + wrcEventData[eventnum]["circuiturl"] + "\");";

		if(eventnum == wrcNextEventIndex) {
			wrcListData[eventnum].color = nextColor;
			wrcListData[eventnum].opacity=255;
		}

//		print(wrcEventData[eventnum]["when"] + "  " + wrcEventData[eventnum]["flag"] + "  " + wrcEventData[eventnum]["where"]);
//		print(wrcEventData[eventnum]["circuiturl"] + "  " + wrcEventData[eventnum]["circuitpic"] + "  " + wrcEventData[eventnum]["circuit"]);
//		print(wrcEventData[eventnum]["podium1"] + "  " + wrcEventData[eventnum]["podium2"] + "  " + wrcEventData[eventnum]["podium3"]);
//		print("-----------------------------------------------------------");
	}
}
	
function wrcEventMouseEnter(eventnum) {
	wrcListData[eventnum].color = onColor;
	wrcListData[eventnum].opacity = 255;
	podiumTitleBackground.vOffset = wrcListBackground[eventnum].vOffset - 18;
	podiumTitleBackground.visible = true;
	podiumTitleText.data = wrcEventData[eventnum]["circuit"];
	podiumTitleText.vOffset = podiumTitleBackground.vOffset + 11;
	podiumTitleText.visible = true;
	podiumBackground1.vOffset = podiumTitleBackground.vOffset +18;
	podiumBackground2.vOffset = podiumTitleBackground.vOffset +36;
	podiumBackground3.vOffset = podiumTitleBackground.vOffset +54;
	podiumBackground1.visible = true;
	podiumBackground2.visible = true;
	podiumBackground3.visible = true;
	podium1.data = "1. " + wrcEventData[eventnum]["podium1"];
	podium2.data = "2. " + wrcEventData[eventnum]["podium2"];
	podium3.data = "3. " + wrcEventData[eventnum]["podium3"];
	if (podium1.data == "1. ?.?????" || podium1.data == "1. ?.??????") {
		podium1.data = "";
		podium2.data = "";
		podium3.data = "";
	}
	podium1.vOffset = podiumBackground1.vOffset + 11;
	podium2.vOffset = podiumBackground2.vOffset + 11;
	podium3.vOffset = podiumBackground3.vOffset + 11;
	podium1.visible = true;
	podium2.visible = true;
	podium3.visible = true;
}

function wrcEventMouseExit(eventnum) {
	if (eventnum == wrcNextEventIndex) {
		wrcListData[eventnum].color = nextColor;
		wrcListData[eventnum].opacity = 255;
	} else {
		wrcListData[eventnum].color = offColor;
		wrcListData[eventnum].opacity = 255;
	}
	podiumTitleBackground.visible = false;
	podiumTitleText.visible = false;
	podiumBackground1.visible = false;
	podiumBackground2.visible = false;
	podiumBackground3.visible = false;
	podium1.visible = false;
	podium2.visible = false;
	podium3.visible = false;
}

function wrcDoList() {
	f1CloseList();
	motogpCloseList();
	if (wrcListState == "open") {
		wrcCloseList();
	} else {
		wrcOpenList();
	}
}

function wrcOpenList() {
	wrcListTitleBackground.visible=true;
	wrcListTitleText.visible=true;
	wrcListState = preferences.wrcListState.value = "open";
	for(i = 1; i <= wrcNumberOfEvents; i++) {
		wrcListBackground[i].visible=true;
		wrcListData[i].visible=true;
	}
	wrcShowList.visible=false;
	wrcHideList.visible=true;
	f1Image.opacity=128;
	motogpImage.opacity=128;
}

function wrcCloseList() {
	if (preferences.wrcListState.value == "closed") {
		return;
	}
	for(i = 1; i <= wrcNumberOfEvents; i++) {
		wrcListBackground[i].visible=false;
		wrcListData[i].visible=false;
	}
	wrcListTitleBackground.visible=false;
	wrcListTitleText.visible=false;
	wrcListState = preferences.wrcListState.value = "closed";
	wrcShowList.visible=true;
	wrcHideList.visible=false;
	f1Image.opacity=255;
	motogpImage.opacity=255;
}

